/* gline.h - Gline database
 * Copyright 2001 srvx Development Team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: gline.h,v 1.2.2.2 2001/04/28 19:23:20 entrope Exp $
 */

#ifndef GLINE_H
#define GLINE_H

struct gline_discrim;
struct gline {
    time_t expires;
    char *issuer;
    char *target;
    char *reason;
};

void gline_init(void);
void gline_add(const char *issuer, const char *target, unsigned long duration, const char *reason, int announce);
void gline_remove(const char *target, int announce);
void gline_refresh(const char *target);
void gline_refresh_all(void);

typedef void (*gline_search_func)(struct gline *gline, void *extra);
struct gline_discrim *gline_discrim_create(struct userNode *user, struct userNode *src, unsigned int argc, unsigned char *argv[]);
unsigned int gline_discrim_search(struct gline_discrim *discrim, gline_search_func gsf, void *data);

#endif /* !defined(GLINE_H) */
